// Example testing sketch for various DHT humidity/temperature sensors
// Written by ladyada, public domain
#include  <Servo.h> //On oublie pas d'ajouter la bibliothèque !
#include "DHT.h"
//création d'un nouveau servomoteur
Servo monServo1;
Servo monServo2;
Servo monServo3;
#define DHTPIN1 2     // what digital pin we're connected to
#define DHTPIN2 6
#define DHTPIN3 3
#define DHTPIN4 7
// Uncomment whatever type you're using!
//#define DHTTYPE DHT11   // DHT 11
#define DHTTYPE DHT22   // DHT 22  (AM2302), AM2321
//#define DHTTYPE DHT21   // DHT 21 (AM2301)

// Connect pin 1 (on the left) of the sensor to +5V
// NOTE: If using a board with 3.3V logic like an Arduino Due connect pin 1
// to 3.3V instead of 5V!
// Connect pin 2 of the sensor to whatever your DHTPIN is
// Connect pin 4 (on the right) of the sensor to GROUND
// Connect a 10K resistor from pin 2 (data) to pin 1 (power) of the sensor

// Initialize DHT sensor.
// Note that older versions of this library took an optional third parameter to
// tweak the timings for faster processors.  This parameter is no longer needed
// as the current DHT reading algorithm adjusts itself to work on faster procs.
DHT dht1(DHTPIN1, DHTTYPE);
DHT dht2(DHTPIN2, DHTTYPE);
DHT dht3(DHTPIN3,DHTTYPE);
DHT dht4(DHTPIN4,DHTTYPE);
int sensorPin1 = A1; // select the input pin for the potentiometer
int sensorPin2 = A0;
int sensorValue1 = 0;
int sensorValue2 = 0;
int button = A2;    // select the input pin for the potentiometer
int a = 0; 

void setup() {
  //on déclare l'entrée du servo connectée sur la broche 9
  monServo1.attach(4);
  monServo2.attach(8);
  monServo3.attach(5);
  Serial.begin(9600);
  Serial.println("DHTxx test!");
  Serial.begin(9600); //Initialisation de la communication avec le moniteur série
  //on met le bouton en entrée
  //on active la résistance de pull-up en mettant la broche à l'état haut (mais cela reste toujours une entrée)
  dht1.begin();
  dht2.begin();
  dht3.begin();
  dht4.begin();
}

void loop() {
  // Wait a few seconds between measurements.
  delay(1000);

  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  float h1 = dht1.readHumidity();
  float h2 = dht2.readHumidity();
  float h3 = dht3.readHumidity();
  float h4 = dht4.readHumidity();
  // Read temperature as Celsius (the default)
  float t1 = dht1.readTemperature();
  float t2 = dht2.readTemperature();
  float t3 = dht3.readTemperature();
  float t4 = dht4.readTemperature();
  // Read temperature as Fahrenheit (isFahrenheit = true)
  float f1 = dht1.readTemperature(true);
  float f2 = dht2.readTemperature(true);
  float f3 = dht3.readTemperature(true);
  float f4 = dht4.readTemperature(true);

  // Check if any reads failed and exit early (to try again).
  if (isnan(h1) || isnan(t1) || isnan(f1)) {
    Serial.println("Failed to read from DHT sensor!");
    
    return ;
  }
  float h = (h1+h2+h3+h4)/4;
  float t = (t1+t2+t3+t4)/4;
  float f = (f1+f2+f3+f4)/4;

  float tempgauche = (t1 + t2)/2;
  float tempdroit = (t3 + t4)/2;
  
  // Compute heat index in Fahrenheit (the default)
  float hif1 = dht1.computeHeatIndex(f1, h1);
  float hif2 = dht2.computeHeatIndex(f2, h2);
  float hif3 = dht3.computeHeatIndex(f3, h3);
  float hif4 = dht4.computeHeatIndex(f4, h4);
  
  
  // Compute heat index in Celsius (isFahreheit = false)
  float hic1 = dht1.computeHeatIndex(t1, h1, false);
  float hic2 = dht2.computeHeatIndex(t2, h2, false);
  float hic3 = dht3.computeHeatIndex(t3, h3, false);
  float hic4 = dht4.computeHeatIndex(t4, h4, false);

  float hif = (hif1+hif2+hif3+hif4)/4;
  float hic =(hic1+hic2+hic3+hic4)/4;

  sensorValue1 = analogRead(sensorPin1);
  Serial.print("valeur de l'humidite en terre droit\t = " );
  Serial.println(sensorValue1);
  sensorValue2 = analogRead(sensorPin2);
  Serial.print("valeur de l'humidite en terre gauche\t = " );
  Serial.println(sensorValue2);
  int humidity=(sensorValue1+sensorValue2)/10;
  if(humidity<45)
  {
    monServo3.write(humidity);
  }
  else
  {
    monServo3.write(45);// Pour eviter un tour complet du servo moteur et une réouverture de la vanne
  }
  

  Serial.print("\n \n Humidity moyenne: \t");
  Serial.print(h);
  Serial.print(" %");
  Serial.print("\n Temperature:\t");
  Serial.print(t);
  Serial.print("\n Temperature capteur gauche: \t");
  Serial.print(tempgauche);
  Serial.print("\n Temperature capteur droit: \t");
  Serial.print(tempdroit);
  Serial.print(" *C \n \n");
  /*Serial.print(f);
  Serial.print("\n *F\t");
  Serial.print("\n Heat index: ");
  Serial.print(hic);
  Serial.print(" *C \n");
  Serial.print(hif);
  Serial.println(" *F");*/
  int val=analogRead(button);// et on l’affecte à la variable "a"
  Serial.print("\n valeu du bouton d'ouverture \t");
  Serial.println(val); // on l'affiche sur le moniteur
  if(val>500)
  {
    monServo1.write(180);
    monServo2.write(0);
  }
  else
  {
    if(tempgauche>26)
    {
      monServo1.write(90);
    }
    else
    {
      monServo1.write(0);
    }
    
    if(tempdroit>26)
    {
      monServo2.write(90);
    }
    else
    {
      monServo2.write(180);
    }
  }
 
  
  
}
